﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DrawScript : MonoBehaviour
{
    private LineRenderer lineRenderer;

    private Vector3 initpos;

    void Start()
    {
        lineRenderer = GetComponent<LineRenderer>();
        initpos = new Vector3(0, 6f, 0);
        DrawPolygon(1024, 1f, this.transform.localPosition, 0.05f, 0.05f);
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    void DrawPolygon(int vertexNumber, float radius, Vector3 centerPos, float startWidth, float endWidth)
    {
        lineRenderer.startWidth = startWidth;
        lineRenderer.endWidth = endWidth;
        lineRenderer.loop = true;
        float angle = 2 * Mathf.PI / vertexNumber;
        lineRenderer.positionCount = vertexNumber;

        for (int i = 0; i < vertexNumber; i++)
        {
            Matrix4x4 rotationMatrix = new Matrix4x4(new Vector4(Mathf.Cos(angle * i), 0, Mathf.Sin(angle * i), 0),
                                                     new Vector4(0, 1, 0, 0),
                                       new Vector4(Mathf.Sin(angle*i), 0, Mathf.Cos(angle*i), 0),
                                       new Vector4(0, 0, 0, 1));
            Vector3 initialRelativePosition = new Vector3(radius, 0, 0);
            lineRenderer.SetPosition(i, centerPos + rotationMatrix.MultiplyPoint(initialRelativePosition));

        }
    }
}
