﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController : MonoBehaviour
{
    private ChuckFloatSyncer ckscaler;

    private Vector3 playerpos;
    private Vector3 mousepos;

    public GameObject blob;
    List<GameObject> blobs = new List<GameObject>();

    private Color playercolor;
    private Color blobcolor;
    private Color newgoalcolor;

    private GameObject maincamera;

    
 


    // Start is called before the first frame update
    void Start()
    {
        for (int i = 0; i < 50; i++)
        {
            makeblob();
        }
        GetComponent<ChuckSubInstance>().RunFile("startist.ck", true);

        ckscaler = gameObject.AddComponent<ChuckFloatSyncer>();
        ckscaler.SyncFloat(GetComponent<ChuckSubInstance>(), "scale");

        maincamera = GameObject.Find("Main Camera");
    }

    int RandomSign()
    {
        return Random.value < .5 ? 1 : -1;
    }

    private int framecount;
    // Update is called once per frame
    void Update()
    {
        framecount++;
        if(framecount % 50 == 0)
        {
            makeblob();
        }
        mousepos = Input.mousePosition;
        mousepos.z = 0;
        Vector3 adjustment = new Vector3(512f, 384f, 0f);
        mousepos -= adjustment;

        
        playerpos = transform.position;

        transform.position += 0.005f * (((1f/64f) * mousepos) - playerpos);
        if (transform.localScale.x > 0)
        {
            transform.localScale = new Vector3(transform.localScale.x - 0.002f, transform.localScale.y, transform.localScale.z - 0.002f);
            float newscale = (0.75f - 0.75f / Mathf.Pow(transform.localScale.x + 1, 0.1f));
            GetComponent<ChuckSubInstance>().SetFloat("scaler", newscale);
        }
        
        maincamera.transform.position = new Vector3(transform.position.x, transform.position.y, -4.5f);

        float ur = playercolor.r + 0.5f * (newgoalcolor.r - playercolor.r);
        float ug = playercolor.g + 0.5f * (newgoalcolor.g - playercolor.g);
        float ub = playercolor.b + 0.5f * (newgoalcolor.b - playercolor.b);
        Color ucolor = new Color(ur, ug, ub);
        this.gameObject.GetComponent<Renderer>().material.SetColor("_BaseColor", ucolor);
        playercolor = this.gameObject.GetComponent<Renderer>().material.GetColor("_BaseColor");
    }

    private void OnTriggerEnter(Collider collision)
    {
        if (collision.gameObject.tag != "Plane") { 
            Destroy(collision.gameObject);
            playercolor = this.gameObject.GetComponent<Renderer>().material.GetColor("_BaseColor");
            blobcolor = collision.gameObject.GetComponent<Renderer>().material.GetColor("_BaseColor");
            float scalefactor = 0.5f * collision.gameObject.transform.localScale.x / (0.5f + this.gameObject.transform.localScale.x);
            float newr = playercolor.r + scalefactor * (blobcolor.r - playercolor.r);
            float newg = playercolor.g + scalefactor * (blobcolor.g - playercolor.g);
            float newb = playercolor.b + scalefactor * (blobcolor.b - playercolor.b);
            newgoalcolor = new Color(newr, newg, newb);
            
            this.gameObject.transform.localScale += (new Vector3(scalefactor, 0f, scalefactor) * 0.5f);
            GetComponent<ChuckSubInstance>().SetFloat("ured", newr);
            GetComponent<ChuckSubInstance>().SetFloat("ugreen", newg);
            GetComponent<ChuckSubInstance>().SetFloat("ublue", newb);
            Debug.Log(newr);
            Debug.Log(newg);
            Debug.Log(newb);
            GetComponent<ChuckSubInstance>().BroadcastEvent("noteChanged");
            GetComponent<ChuckSubInstance>().SetFloat("bluefreq", (3580-3540*newgoalcolor.b));
            GetComponent<ChuckSubInstance>().SetFloat("tubegain", 0.5 * Mathf.Exp(1.5f * newgoalcolor.g - 1.5f));
            GetComponent<ChuckSubInstance>().SetFloat("threegain", 0.5 * Mathf.Exp(3f * newgoalcolor.g - 3f));
            GetComponent<ChuckSubInstance>().SetFloat("flutegain", 0.5 * Mathf.Exp(4.5f * newgoalcolor.g - 4.5f));
            GetComponent<ChuckSubInstance>().SetFloat("tremfreq", 2f + 10f * newgoalcolor.r);
            GetComponent<ChuckSubInstance>().SetFloat("tremdepth", 0.0001f + 0.0008f * newgoalcolor.r);
            
        }
        
    }

    

    private void makeblob()
    {
        float xpos = RandomSign() * Random.Range(1.2f, 7f);
        float ypos = RandomSign() * Random.Range(1.2f, 5f);
        Vector3 instantpos = new Vector3(xpos, ypos, 0);
        GameObject newblob = Instantiate(blob, instantpos, Quaternion.Euler(-90, 0, 0));
        var renderer = newblob.GetComponent<Renderer>();
        Color randcolor = new Color(Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f));
        renderer.material.SetColor("_BaseColor", randcolor);
        newblob.transform.localScale *= Random.Range(0.25f, 0.75f);
        blobs.Add(newblob);
    }
}
