﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Playhead : MonoBehaviour
{
    private ChuckFloatSyncer ckpheadangle;
    List<GameObject> spores = new List<GameObject>();

    private ChuckIntSyncer ckcyclecount;

    private GameObject selected;

    private float cycle_dur = 3600f;
    private Vector3 scaleAdder;
    
    private float sporefreq;
    public GameObject sporePrefab;
  
    private bool pause = true;
    // Start is called before the first frame update
    void Start()
    {
        GetComponent<ChuckSubInstance>().RunFile("petriquencer.ck", true);

        // add the float sync
        ckpheadangle = gameObject.AddComponent<ChuckFloatSyncer>();
        ckpheadangle.SyncFloat(GetComponent<ChuckSubInstance>(), "pheadangle");

        ckcyclecount = gameObject.AddComponent<ChuckIntSyncer>();
        ckcyclecount.SyncInt(GetComponent<ChuckSubInstance>(), "ckcyclecount");

    }

    void AddSpore(Vector3 instantpos)
    {
        spores.Add(Instantiate(sporePrefab, instantpos, Quaternion.Euler(0, 0, 0)));
        sporefreq = 65f * Mathf.Pow(2.38305f, Mathf.Sqrt(Mathf.Pow(instantpos.x, 2) + Mathf.Pow(instantpos.z, 2)));
        GetComponent<ChuckSubInstance>().SetFloat("freq_of_spore2add", sporefreq);
        GetComponent<ChuckSubInstance>().BroadcastEvent("sporeAdded");
    }

    public void sporecollide(GameObject gotten)
    {
        gotten.transform.localScale = gotten.transform.localScale + new Vector3(0.033f, 0f, 0.033f);
        foreach (GameObject tester in spores){
            if(tester == gotten)
            {
                GetComponent<ChuckSubInstance>().SetInt("spore_to_play", spores.IndexOf(tester));
                Debug.Log(spores.IndexOf(tester));
                GetComponent<ChuckSubInstance>().BroadcastEvent("sporePlayed");
                
            }
        } 
    }

    // Update is called once per frame
    void Update()
    {
        this.transform.rotation = Quaternion.Euler(0, -ckpheadangle.GetCurrentValue(), 0);
        if (Input.GetMouseButtonDown(0))
        {
            RaycastHit hit;
            if (Physics.Raycast(Camera.main.ScreenPointToRay(Input.mousePosition), out hit, 100))
            {
                
                if (hit.collider.gameObject.tag == "Spore") {
                    selected = hit.collider.gameObject;
                } else
                {
                    AddSpore(new Vector3(hit.point.x, 0, hit.point.z));
                }
            }
        }

        if (Input.GetKeyDown("up"))
        {
            if (cycle_dur >= 1844f) { 
            cycle_dur *= 0.8f; }
            GetComponent<ChuckSubInstance>().SetFloat("cycle_dur", cycle_dur);
        }
        else if (Input.GetKeyDown("down"))
        {
            if (cycle_dur <= 7031f) { 
            cycle_dur *= 1.25f; }
            GetComponent<ChuckSubInstance>().SetFloat("cycle_dur", cycle_dur);
        }
        else if (Input.GetKeyDown(KeyCode.P))
        {
            if (pause)
            {
                GetComponent<ChuckSubInstance>().SetInt("pausetoggle", 3600);
            }
            else if (!pause)
            {
                GetComponent<ChuckSubInstance>().SetInt("pausetoggle", 0);
            }
            pause = !pause;
        }
        else if (Input.GetKeyDown(KeyCode.X))
        {
            selected.SetActive(false);
        }
        else if (Input.GetKeyDown(KeyCode.Q))
        { 
              GetComponent<ChuckSubInstance>().SetFloat("newgain", 1.5f);
              GetComponent<ChuckSubInstance>().SetInt("gainchangee", spores.IndexOf(selected));
            selected.transform.localScale = selected.transform.localScale + new Vector3(0, 0.1f, 0);
            GetComponent<ChuckSubInstance>().BroadcastEvent("sporeGained");
        }
        else if (Input.GetKeyDown(KeyCode.A)){
            GetComponent<ChuckSubInstance>().SetFloat("newgain", 0.667f);
            GetComponent<ChuckSubInstance>().SetInt("gainchangee", spores.IndexOf(selected));
            selected.transform.position = selected.transform.position + new Vector3(0, -0.05f, 0);
            GetComponent<ChuckSubInstance>().BroadcastEvent("sporeGained");
        }

        if (ckcyclecount.GetCurrentValue() >= cycle_dur)
        {
            
            GetComponent<ChuckSubInstance>().SetInt("ckcyclecount", 0);
        };

    }
}
