Gain threemix;
0=>threemix.gain;
Gain clarmix;
0.5 => clarmix.gain;
Gain flutemix;
0=>flutemix.gain;
Gain tubemix;
0=>tubemix.gain;
Gain master;
Gain scale;
LPF blue;
1750 => blue.freq;
0.0015 => master.gain;

1.0 => global float scaler;

0.5 => global float ured;
0.5 => global float ugreen;
0.5 => global float ublue;

0.5 => global float uredlast;
0.5 => global float ugreenlast;
0.5 => global float ubluelast;

BeeThree threes[0];
for(0 => int i; i<4; i++){
    BeeThree three => threemix => master => blue => scale => dac;
    0.4 => three.noteOn;
    threes << three;
}

float notes[4];
Std.mtof(48) => notes[0];
Std.mtof(55) => notes[1];
Std.mtof(64) => notes[2];
Std.mtof(71) => notes[3];


Clarinet clars[0];
for(0 => int i; i<4; i++){    
    Clarinet clar => clarmix => master => blue => scale => dac;    
    0.2 => clar.noteOn;    
    clars << clar;    
}


Flute flutes[0];
for(0 => int i; i<4; i++){    
    Flute flute => flutemix => master => blue => scale => dac;    
    0.2 => flute.noteOn;    
    flutes << flute;    
}


TubeBell tubes[0];
for(0 => int i; i<4; i++){    
    TubeBell tube => tubemix => master => blue => scale => dac;    
    0.4 => tube.noteOn;    
    tubes << tube;    
}



1750 => global float bluefreq;
0=>global float threegain;
0=>global float tubegain;
0=>global float flutegain;

SinOsc tremlfo => blackhole;
2 => global float tremfreq => tremlfo.freq;
0.00015 => global float tremdepth; 

global Event noteChanged;

spork ~ bluetracker();
spork ~ greentracker();
spork ~ noteChanger();

noteSet();

while(true){
   
    1::ms=>now;
    (tremlfo.last() * tremdepth + 0.001) => master.gain;
    scaler => scale.gain;
    tremfreq => tremlfo.freq;
}




fun void bluetracker(){
    while(true){
        1::ms=>now;
        bluefreq => blue.freq; 
    }
}

fun void greentracker(){
    while(true){
        1::ms=>now;
        threegain => threemix.gain;
        tubegain => tubemix.gain;
        flutegain => flutemix.gain;
    }
}

fun void noteChanger(){
    while(true)
    {
        noteChanged => now;
        0.01 => master.gain;
        ured - uredlast => float redchange;
        ugreen - ugreenlast => float greenchange;
        ublue - ubluelast => float bluechange;
        
        
        if(determiner(redchange, greenchange, bluechange)[0] <= -1){
            notes[0] / Math.pow(2, (1./12)) => notes[0];
            noteUpdater(0);
        }
        if(determiner(redchange, greenchange, bluechange)[0] >= 1){
            notes[0] * Math.pow(2, (1./12)) => notes[0];
            noteUpdater(0);
        }
        if(determiner(redchange, greenchange, bluechange)[1] <= -1){
            notes[1] / Math.pow(2, (1./12)) => notes[1];
            noteUpdater(1);
        }
        if(determiner(redchange, greenchange, bluechange)[1] >= 1){
            notes[1] * Math.pow(2, (1./12)) => notes[1];
            noteUpdater(1);
        }
        if(determiner(redchange, greenchange, bluechange)[2] <= -1){
            notes[2] / Math.pow(2, (1./12)) => notes[2];
            noteUpdater(2);
        }
        if(determiner(redchange, greenchange, bluechange)[2] >= 1){
            notes[2] * Math.pow(2, (1./12)) => notes[2];
            noteUpdater(2);
        }
        if(determiner(redchange, greenchange, bluechange)[3] <= -1){
            notes[3] / Math.pow(2, (1./12)) => notes[3];
            noteUpdater(3);
        }
        if(determiner(redchange, greenchange, bluechange)[3] >= 1){
            notes[3] * Math.pow(2, (1./12)) => notes[3];
            noteUpdater(3);
        }
        
        
        
        ured => uredlast;
        ublue => ubluelast;
        ugreen => ugreenlast;
    }
}

fun int[] determiner(float redchange, float greenchange, float bluechange){
    int result[4];
    0 => result[0];
    0 => result[1];
    0 => result[2];
    0 => result[3];
    if(bluechange <= -0.3){
        result[0] + 1 => result[0];
        result[1] + 1 => result[1];
    }
    if(-0.3 < bluechange && bluechange <= -0.1){
        result[1] + 1 => result[1];
    }
    if(0.3 >= bluechange && bluechange >= 0.1){
        result[0] - 1 => result[0];
    }
    if(bluechange > 0.3){
        result[0] - 1 => result[0];
        result[1] - 1 => result[1];
    }
    if(greenchange <= -0.3){
        result[1] - 1 => result[1];
        result[2] + 1 => result[2];
    }
    if(-0.3 < greenchange && greenchange <= -0.1){
        result[1] - 1 => result[1];
    }
    if(0.3 >= greenchange && greenchange >= 0.1){
        result[2] - 1 => result[2];
    }
    if(greenchange > 0.3){
        result[1] + 1 => result[1];
        result[2] - 1 => result[2];
    }
    if(redchange <= -0.3){
        result[2] - 1 => result[2];
        result[3] - 1 => result[3];
    }
    if(-0.3 < redchange && redchange <= -0.1){
        result[3] - 1 => result[3];
    }
    if(0.3 >= redchange && redchange >= 0.1){
        result[2] + 1 => result[2];
    }
    if(redchange > 0.3){
        result[2] + 1 => result[2];
        result[3] + 1 => result[3];
    }
    return result;
}

fun void noteSet(){
     notes[0] => tubes[0].freq;
notes[1] => tubes[1].freq;
notes[2] => tubes[2].freq;
notes[3] => tubes[3].freq;

notes[0] => threes[0].freq;
notes[1] => threes[1].freq;
notes[2] => threes[2].freq;
notes[3] => threes[3].freq;

notes[0] => flutes[0].freq;
notes[1] => flutes[1].freq;
notes[2] => flutes[2].freq;
notes[3] => flutes[3].freq;

notes[0] => clars[0].freq;
notes[1] => clars[1].freq;
notes[2] => clars[2].freq;
notes[3] => clars[3].freq;



}

fun void noteUpdater(int tochange){
    tubes[tochange].noteOff;
    clars[tochange].noteOff;
    flutes[tochange].noteOff;
    threes[tochange].noteOff;
    
    notes[tochange] => tubes[tochange].freq;
    notes[tochange] => flutes[tochange].freq;
    notes[tochange] => clars[tochange].freq;
    notes[tochange] => threes[tochange].freq;
    
    0.4 => tubes[tochange].noteOn;
    0.4 => threes[tochange].noteOn;
    0.2 => flutes[tochange].noteOn;
    0.2 => clars[tochange].noteOn;
}